/* Include files */

#include "blascompat32.h"
#include "dstatcom_dPQ_sfun.h"
#include "c4_dstatcom_dPQ.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "dstatcom_dPQ_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c4_IN_NO_ACTIVE_CHILD          (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc4_dstatcom_dPQInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c4_dstatcom_dPQ(void);
static void initialize_params_c4_dstatcom_dPQ(void);
static void enable_c4_dstatcom_dPQ(void);
static void disable_c4_dstatcom_dPQ(void);
static void c4_update_debugger_state_c4_dstatcom_dPQ(void);
static const mxArray *get_sim_state_c4_dstatcom_dPQ(void);
static void set_sim_state_c4_dstatcom_dPQ(const mxArray *c4_st);
static void finalize_c4_dstatcom_dPQ(void);
static void sf_c4_dstatcom_dPQ(void);
static void init_script_number_translation(uint32_T c4_machineNumber, uint32_T
  c4_chartNumber);
static const mxArray *c4_sf_marshall(void *c4_chartInstance, void *c4_u);
static const mxArray *c4_emlrt_marshallOut(uint8_T c4_u);
static real_T c4_emlrt_marshallIn(const mxArray *c4_y, char *c4_name);
static uint8_T c4_b_emlrt_marshallIn(const mxArray
  *c4_b_is_active_c4_dstatcom_dPQ, char *c4_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c4_dstatcom_dPQ(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c4_is_active_c4_dstatcom_dPQ = 0U;
}

static void initialize_params_c4_dstatcom_dPQ(void)
{
}

static void enable_c4_dstatcom_dPQ(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c4_dstatcom_dPQ(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c4_update_debugger_state_c4_dstatcom_dPQ(void)
{
}

static const mxArray *get_sim_state_c4_dstatcom_dPQ(void)
{
  const mxArray *c4_st = NULL;
  const mxArray *c4_y = NULL;
  real_T c4_u;
  const mxArray *c4_b_y = NULL;
  real_T *c4_c_y;
  c4_c_y = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c4_st = NULL;
  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_createcellarray(2));
  c4_u = *c4_c_y;
  c4_b_y = NULL;
  sf_mex_assign(&c4_b_y, sf_mex_create("y", &c4_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c4_y, 0, c4_b_y);
  sf_mex_setcell(c4_y, 1, c4_emlrt_marshallOut
                 (chartInstance.c4_is_active_c4_dstatcom_dPQ));
  sf_mex_assign(&c4_st, c4_y);
  return c4_st;
}

static void set_sim_state_c4_dstatcom_dPQ(const mxArray *c4_st)
{
  const mxArray *c4_u;
  real_T *c4_y;
  c4_y = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c4_doneDoubleBufferReInit = true;
  c4_u = sf_mex_dup(c4_st);
  *c4_y = c4_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c4_u, 0)), "y");
  chartInstance.c4_is_active_c4_dstatcom_dPQ = c4_b_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c4_u, 1)), "is_active_c4_dstatcom_dPQ");
  sf_mex_destroy(&c4_u);
  c4_update_debugger_state_c4_dstatcom_dPQ();
  sf_mex_destroy(&c4_st);
}

static void finalize_c4_dstatcom_dPQ(void)
{
}

static void sf_c4_dstatcom_dPQ(void)
{
  uint8_T c4_previousEvent;
  real_T c4_u1;
  real_T c4_u2;
  real_T c4_u3;
  real_T c4_u4;
  real_T c4_nargout = 1.0;
  real_T c4_nargin = 4.0;
  real_T c4_y;
  real_T *c4_b_u1;
  real_T *c4_b_y;
  real_T *c4_b_u2;
  real_T *c4_b_u3;
  real_T *c4_b_u4;
  c4_b_u2 = (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
  c4_b_u3 = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
  c4_b_u1 = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
  c4_b_u4 = (real_T *)ssGetInputPortSignal(chartInstance.S, 3);
  c4_b_y = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,1);
  _SFD_DATA_RANGE_CHECK(*c4_b_u1, 0U);
  _SFD_DATA_RANGE_CHECK(*c4_b_y, 1U);
  _SFD_DATA_RANGE_CHECK(*c4_b_u2, 2U);
  _SFD_DATA_RANGE_CHECK(*c4_b_u3, 3U);
  _SFD_DATA_RANGE_CHECK(*c4_b_u4, 4U);
  c4_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,1);
  c4_u1 = *c4_b_u1;
  c4_u2 = *c4_b_u2;
  c4_u3 = *c4_b_u3;
  c4_u4 = *c4_b_u4;
  sf_debug_symbol_scope_push(7U, 0U);
  sf_debug_symbol_scope_add("nargout", &c4_nargout, c4_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c4_nargin, c4_sf_marshall);
  sf_debug_symbol_scope_add("y", &c4_y, c4_sf_marshall);
  sf_debug_symbol_scope_add("u4", &c4_u4, c4_sf_marshall);
  sf_debug_symbol_scope_add("u3", &c4_u3, c4_sf_marshall);
  sf_debug_symbol_scope_add("u2", &c4_u2, c4_sf_marshall);
  sf_debug_symbol_scope_add("u1", &c4_u1, c4_sf_marshall);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0,4);
  if (CV_EML_IF(0, 0, ((c4_u1 + c4_u2) + c4_u3) + c4_u4 == 4.0)) {
    _SFD_EML_CALL(0,5);
    c4_y = 1.0;
  } else {
    _SFD_EML_CALL(0,6);
    if (CV_EML_IF(0, 1, ((c4_u1 + c4_u2) + c4_u3) + c4_u4 == 3.0)) {
      _SFD_EML_CALL(0,7);
      c4_y = 2.0;
    } else {
      _SFD_EML_CALL(0,8);
      if (CV_EML_IF(0, 2, c4_u4 == 0.0)) {
        _SFD_EML_CALL(0,9);
        c4_y = 3.0;
      } else {
        _SFD_EML_CALL(0,10);
        c4_y = 4.0;
      }
    }
  }

  _SFD_EML_CALL(0,-10);
  sf_debug_symbol_scope_pop();
  *c4_b_y = c4_y;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,1);
  _sfEvent_ = c4_previousEvent;
  sf_debug_check_for_state_inconsistency(_dstatcom_dPQMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c4_machineNumber, uint32_T
  c4_chartNumber)
{
}

static const mxArray *c4_sf_marshall(void *c4_chartInstance, void *c4_u)
{
  const mxArray *c4_y = NULL;
  real_T c4_b_u;
  const mxArray *c4_b_y = NULL;
  c4_y = NULL;
  c4_b_u = *((real_T *)c4_u);
  c4_b_y = NULL;
  sf_mex_assign(&c4_b_y, sf_mex_create("y", &c4_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c4_y, c4_b_y);
  return c4_y;
}

const mxArray *sf_c4_dstatcom_dPQ_get_eml_resolved_functions_info(void)
{
  const mxArray *c4_nameCaptureInfo = NULL;
  c4_ResolvedFunctionInfo c4_info[2];
  c4_ResolvedFunctionInfo (*c4_b_info)[2];
  const mxArray *c4_m0 = NULL;
  int32_T c4_i0;
  c4_ResolvedFunctionInfo *c4_r0;
  c4_nameCaptureInfo = NULL;
  c4_b_info = (c4_ResolvedFunctionInfo (*)[2])c4_info;
  (*c4_b_info)[0].context = "";
  (*c4_b_info)[0].name = "plus";
  (*c4_b_info)[0].dominantType = "double";
  (*c4_b_info)[0].resolved = "[B]plus";
  (*c4_b_info)[0].fileLength = 0U;
  (*c4_b_info)[0].fileTime1 = 0U;
  (*c4_b_info)[0].fileTime2 = 0U;
  (*c4_b_info)[1].context = "";
  (*c4_b_info)[1].name = "eq";
  (*c4_b_info)[1].dominantType = "double";
  (*c4_b_info)[1].resolved = "[B]eq";
  (*c4_b_info)[1].fileLength = 0U;
  (*c4_b_info)[1].fileTime1 = 0U;
  (*c4_b_info)[1].fileTime2 = 0U;
  sf_mex_assign(&c4_m0, sf_mex_createstruct("nameCaptureInfo", 1, 2));
  for (c4_i0 = 0; c4_i0 < 2; c4_i0 = c4_i0 + 1) {
    c4_r0 = &c4_info[c4_i0];
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c4_r0->context)), "context",
                    "nameCaptureInfo", c4_i0);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c4_r0->name)), "name",
                    "nameCaptureInfo", c4_i0);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c4_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c4_i0);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", c4_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c4_r0->resolved)), "resolved"
                    , "nameCaptureInfo", c4_i0);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c4_i0);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->fileTime1, 7,
      0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo", c4_i0);
    sf_mex_addfield(c4_m0, sf_mex_create("nameCaptureInfo", &c4_r0->fileTime2, 7,
      0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo", c4_i0);
  }

  sf_mex_assign(&c4_nameCaptureInfo, c4_m0);
  return c4_nameCaptureInfo;
}

static const mxArray *c4_emlrt_marshallOut(uint8_T c4_u)
{
  const mxArray *c4_y = NULL;
  c4_y = NULL;
  sf_mex_assign(&c4_y, sf_mex_create("y", &c4_u, 3, 0U, 0U, 0U, 0));
  return c4_y;
}

static real_T c4_emlrt_marshallIn(const mxArray *c4_y, char *c4_name)
{
  real_T c4_b_y;
  real_T c4_d0;
  sf_mex_import(c4_name, sf_mex_dup(c4_y), &c4_d0, 1, 0, 0U, 0, 0U, 0);
  c4_b_y = c4_d0;
  sf_mex_destroy(&c4_y);
  return c4_b_y;
}

static uint8_T c4_b_emlrt_marshallIn(const mxArray
  *c4_b_is_active_c4_dstatcom_dPQ, char *c4_name)
{
  uint8_T c4_y;
  uint8_T c4_u0;
  sf_mex_import(c4_name, sf_mex_dup(c4_b_is_active_c4_dstatcom_dPQ), &c4_u0, 1,
                3, 0U, 0, 0U, 0);
  c4_y = c4_u0;
  sf_mex_destroy(&c4_b_is_active_c4_dstatcom_dPQ);
  return c4_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c4_dstatcom_dPQ_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1671944766U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2140541079U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(128548350U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(4109164038U);
}

mxArray *sf_c4_dstatcom_dPQ_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(3158878038U);
    pr[1] = (double)(295520201U);
    pr[2] = (double)(2171203362U);
    pr[3] = (double)(2971017767U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }

    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }

    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }

    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c4_dstatcom_dPQ(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"y\",},{M[8],M[0],T\"is_active_c4_dstatcom_dPQ\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c4_dstatcom_dPQ_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_dstatcom_dPQMachineNumber_,
           4,
           1,
           1,
           5,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance.chartNumber),
           &(chartInstance.instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_dstatcom_dPQMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_dstatcom_dPQMachineNumber_,chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_dstatcom_dPQMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);
          _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"u1",0,
                              c4_sf_marshall);
          _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"y",0,
                              NULL);
          _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"u2",0,
                              NULL);
          _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"u3",0,
                              NULL);
          _SFD_SET_DATA_PROPS(4,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"u4",0,
                              NULL);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,3,0,0,0,0,0);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,149);
        _SFD_CV_INIT_EML_IF(0,0,37,54,64,148);
        _SFD_CV_INIT_EML_IF(0,1,64,85,95,148);
        _SFD_CV_INIT_EML_IF(0,2,100,108,127,144);
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T *c4_u1;
          real_T *c4_y;
          real_T *c4_u2;
          real_T *c4_u3;
          real_T *c4_u4;
          c4_u2 = (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
          c4_u3 = (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
          c4_u1 = (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
          c4_u4 = (real_T *)ssGetInputPortSignal(chartInstance.S, 3);
          c4_y = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
          _SFD_SET_DATA_VALUE_PTR(0U, c4_u1);
          _SFD_SET_DATA_VALUE_PTR(1U, c4_y);
          _SFD_SET_DATA_VALUE_PTR(2U, c4_u2);
          _SFD_SET_DATA_VALUE_PTR(3U, c4_u3);
          _SFD_SET_DATA_VALUE_PTR(4U, c4_u4);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_dstatcom_dPQMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c4_dstatcom_dPQ(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c4_dstatcom_dPQ();
  initialize_c4_dstatcom_dPQ();
}

static void sf_opaque_enable_c4_dstatcom_dPQ(void *chartInstanceVar)
{
  enable_c4_dstatcom_dPQ();
}

static void sf_opaque_disable_c4_dstatcom_dPQ(void *chartInstanceVar)
{
  disable_c4_dstatcom_dPQ();
}

static void sf_opaque_gateway_c4_dstatcom_dPQ(void *chartInstanceVar)
{
  sf_c4_dstatcom_dPQ();
}

static mxArray* sf_opaque_get_sim_state_c4_dstatcom_dPQ(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c4_dstatcom_dPQ();
  return st;
}

static void sf_opaque_set_sim_state_c4_dstatcom_dPQ(void *chartInstanceVar,
  const mxArray *st)
{
  set_sim_state_c4_dstatcom_dPQ(sf_mex_dup(st));
}

static void sf_opaque_terminate_c4_dstatcom_dPQ(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c4_dstatcom_dPQ();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c4_dstatcom_dPQ(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c4_dstatcom_dPQ();
  }
}

static void mdlSetWorkWidths_c4_dstatcom_dPQ(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("dstatcom_dPQ","dstatcom_dPQ",4);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("dstatcom_dPQ","dstatcom_dPQ",4,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("dstatcom_dPQ",
      "dstatcom_dPQ",4,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"dstatcom_dPQ","dstatcom_dPQ",4,4);
      sf_mark_chart_reusable_outputs(S,"dstatcom_dPQ","dstatcom_dPQ",4,1);
    }

    sf_set_rtw_dwork_info(S,"dstatcom_dPQ","dstatcom_dPQ",4);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(3603808489U));
  ssSetChecksum1(S,(2199675540U));
  ssSetChecksum2(S,(3171284730U));
  ssSetChecksum3(S,(155879561U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c4_dstatcom_dPQ(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "dstatcom_dPQ", "dstatcom_dPQ",4);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c4_dstatcom_dPQ(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c4_dstatcom_dPQ;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c4_dstatcom_dPQ;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c4_dstatcom_dPQ;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c4_dstatcom_dPQ;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c4_dstatcom_dPQ;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c4_dstatcom_dPQ;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c4_dstatcom_dPQ;
  chartInstance.chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c4_dstatcom_dPQ;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c4_dstatcom_dPQ;
  chartInstance.chartInfo.mdlStart = mdlStart_c4_dstatcom_dPQ;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c4_dstatcom_dPQ;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c4_dstatcom_dPQ_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c4_dstatcom_dPQ(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c4_dstatcom_dPQ(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c4_dstatcom_dPQ(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c4_dstatcom_dPQ_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
