/* Include files */

#include "blascompat32.h"
#include "dstatcom_dPQ_sfun.h"
#include "c2_dstatcom_dPQ.h"
#define CHARTINSTANCE_CHARTNUMBER      (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER   (chartInstance.instanceNumber)
#include "dstatcom_dPQ_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c2_IN_NO_ACTIVE_CHILD          (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc2_dstatcom_dPQInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c2_dstatcom_dPQ(void);
static void initialize_params_c2_dstatcom_dPQ(void);
static void enable_c2_dstatcom_dPQ(void);
static void disable_c2_dstatcom_dPQ(void);
static void c2_update_debugger_state_c2_dstatcom_dPQ(void);
static const mxArray *get_sim_state_c2_dstatcom_dPQ(void);
static void set_sim_state_c2_dstatcom_dPQ(const mxArray *c2_st);
static void finalize_c2_dstatcom_dPQ(void);
static void sf_c2_dstatcom_dPQ(void);
static void init_script_number_translation(uint32_T c2_machineNumber, uint32_T
  c2_chartNumber);
static const mxArray *c2_sf_marshall(void *c2_chartInstance, void *c2_u);
static const mxArray *c2_b_sf_marshall(void *c2_chartInstance, void *c2_u);
static const mxArray *c2_emlrt_marshallOut(uint8_T c2_u);
static real_T c2_emlrt_marshallIn(const mxArray *c2_y, char *c2_name);
static uint8_T c2_b_emlrt_marshallIn(const mxArray
  *c2_b_is_active_c2_dstatcom_dPQ, char *c2_name);
static void init_io_bus_offset(void);
static void init_dsm_address_info(void);

/* Function Definitions */
static void initialize_c2_dstatcom_dPQ(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c2_is_active_c2_dstatcom_dPQ = 0U;
}

static void initialize_params_c2_dstatcom_dPQ(void)
{
}

static void enable_c2_dstatcom_dPQ(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void disable_c2_dstatcom_dPQ(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
}

static void c2_update_debugger_state_c2_dstatcom_dPQ(void)
{
}

static const mxArray *get_sim_state_c2_dstatcom_dPQ(void)
{
  const mxArray *c2_st = NULL;
  const mxArray *c2_y = NULL;
  real_T c2_u;
  const mxArray *c2_b_y = NULL;
  real_T *c2_c_y;
  c2_c_y = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c2_st = NULL;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_createcellarray(2));
  c2_u = *c2_c_y;
  c2_b_y = NULL;
  sf_mex_assign(&c2_b_y, sf_mex_create("y", &c2_u, 0, 0U, 0U, 0U, 0));
  sf_mex_setcell(c2_y, 0, c2_b_y);
  sf_mex_setcell(c2_y, 1, c2_emlrt_marshallOut
                 (chartInstance.c2_is_active_c2_dstatcom_dPQ));
  sf_mex_assign(&c2_st, c2_y);
  return c2_st;
}

static void set_sim_state_c2_dstatcom_dPQ(const mxArray *c2_st)
{
  const mxArray *c2_u;
  real_T *c2_y;
  c2_y = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  chartInstance.c2_doneDoubleBufferReInit = true;
  c2_u = sf_mex_dup(c2_st);
  *c2_y = c2_emlrt_marshallIn(sf_mex_dup(sf_mex_getcell(c2_u, 0)), "y");
  chartInstance.c2_is_active_c2_dstatcom_dPQ = c2_b_emlrt_marshallIn(sf_mex_dup
    (sf_mex_getcell(c2_u, 1)), "is_active_c2_dstatcom_dPQ");
  sf_mex_destroy(&c2_u);
  c2_update_debugger_state_c2_dstatcom_dPQ();
  sf_mex_destroy(&c2_st);
}

static void finalize_c2_dstatcom_dPQ(void)
{
}

static void sf_c2_dstatcom_dPQ(void)
{
  int32_T c2_i0;
  uint8_T c2_previousEvent;
  int32_T c2_i1;
  real_T c2_u[6];
  real_T c2_nargout = 1.0;
  real_T c2_nargin = 1.0;
  real_T c2_y;
  real_T *c2_b_y;
  real_T (*c2_b_u)[6];
  c2_b_y = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
  c2_b_u = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 0);
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_CC_CALL(CHART_ENTER_SFUNCTION_TAG,0);
  for (c2_i0 = 0; c2_i0 < 6; c2_i0 = c2_i0 + 1) {
    _SFD_DATA_RANGE_CHECK((*c2_b_u)[c2_i0], 0U);
  }

  _SFD_DATA_RANGE_CHECK(*c2_b_y, 1U);
  c2_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,0);
  for (c2_i1 = 0; c2_i1 < 6; c2_i1 = c2_i1 + 1) {
    c2_u[c2_i1] = (*c2_b_u)[c2_i1];
  }

  sf_debug_symbol_scope_push(4U, 0U);
  sf_debug_symbol_scope_add("nargout", &c2_nargout, c2_b_sf_marshall);
  sf_debug_symbol_scope_add("nargin", &c2_nargin, c2_b_sf_marshall);
  sf_debug_symbol_scope_add("y", &c2_y, c2_b_sf_marshall);
  sf_debug_symbol_scope_add("u", &c2_u, c2_sf_marshall);
  CV_EML_FCN(0, 0);
  _SFD_EML_CALL(0,3);
  if (CV_EML_COND(0, 0, c2_u[0] == 2011.0)) {
  } else if (CV_EML_COND(0, 1, c2_u[0] == 2012.0)) {
  } else {
    goto label_1;
  }

  if (CV_EML_COND(0, 2, c2_u[1] == 12.0)) {
    goto label_2;
  } else if (CV_EML_COND(0, 3, c2_u[1] == 1.0)) {
    goto label_2;
  } else if (CV_EML_COND(0, 4, c2_u[1] == 2.0)) {
    goto label_3;
  } else if (CV_EML_COND(0, 5, c2_u[1] == 3.0)) {
    goto label_4;
  } else if (CV_EML_COND(0, 6, c2_u[1] == 4.0)) {
    goto label_5;
  } else {
    if (CV_EML_COND(0, 7, c2_u[1] == 5.0)) {
      goto label_6;
    }
  }

 label_1:
  ;
  CV_EML_MCDC(0, 0, false);
  CV_EML_IF(0, 0, false);
  _SFD_EML_CALL(0,5);
  c2_y = 1.0;
  goto label_7;
 label_2:
  ;
 label_3:
  ;
 label_4:
  ;
 label_5:
  ;
 label_6:
  ;
  CV_EML_MCDC(0, 0, true);
  CV_EML_IF(0, 0, true);
  _SFD_EML_CALL(0,4);
  c2_y = 0.0;
 label_7:
  ;
  _SFD_EML_CALL(0,-5);
  sf_debug_symbol_scope_pop();
  *c2_b_y = c2_y;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,0);
  _sfEvent_ = c2_previousEvent;
  sf_debug_check_for_state_inconsistency(_dstatcom_dPQMachineNumber_,
    chartInstance.chartNumber, chartInstance.instanceNumber);
}

static void init_script_number_translation(uint32_T c2_machineNumber, uint32_T
  c2_chartNumber)
{
}

static const mxArray *c2_sf_marshall(void *c2_chartInstance, void *c2_u)
{
  const mxArray *c2_y = NULL;
  int32_T c2_i2;
  real_T c2_b_u[6];
  const mxArray *c2_b_y = NULL;
  c2_y = NULL;
  for (c2_i2 = 0; c2_i2 < 6; c2_i2 = c2_i2 + 1) {
    c2_b_u[c2_i2] = (*((real_T (*)[6])c2_u))[c2_i2];
  }

  c2_b_y = NULL;
  sf_mex_assign(&c2_b_y, sf_mex_create("y", &c2_b_u, 0, 0U, 1U, 0U, 1, 6));
  sf_mex_assign(&c2_y, c2_b_y);
  return c2_y;
}

static const mxArray *c2_b_sf_marshall(void *c2_chartInstance, void *c2_u)
{
  const mxArray *c2_y = NULL;
  real_T c2_b_u;
  const mxArray *c2_b_y = NULL;
  c2_y = NULL;
  c2_b_u = *((real_T *)c2_u);
  c2_b_y = NULL;
  sf_mex_assign(&c2_b_y, sf_mex_create("y", &c2_b_u, 0, 0U, 0U, 0U, 0));
  sf_mex_assign(&c2_y, c2_b_y);
  return c2_y;
}

const mxArray *sf_c2_dstatcom_dPQ_get_eml_resolved_functions_info(void)
{
  const mxArray *c2_nameCaptureInfo = NULL;
  c2_ResolvedFunctionInfo c2_info[1];
  c2_ResolvedFunctionInfo (*c2_b_info)[1];
  const mxArray *c2_m0 = NULL;
  int32_T c2_i3;
  c2_ResolvedFunctionInfo *c2_r0;
  c2_nameCaptureInfo = NULL;
  c2_b_info = (c2_ResolvedFunctionInfo (*)[1])c2_info;
  (*c2_b_info)[0].context = "";
  (*c2_b_info)[0].name = "eq";
  (*c2_b_info)[0].dominantType = "double";
  (*c2_b_info)[0].resolved = "[B]eq";
  (*c2_b_info)[0].fileLength = 0U;
  (*c2_b_info)[0].fileTime1 = 0U;
  (*c2_b_info)[0].fileTime2 = 0U;
  sf_mex_assign(&c2_m0, sf_mex_createstruct("nameCaptureInfo", 1, 1));
  for (c2_i3 = 0; c2_i3 < 1; c2_i3 = c2_i3 + 1) {
    c2_r0 = &c2_info[c2_i3];
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->context, 15,
      0U, 0U, 0U, 2, 1, strlen(c2_r0->context)), "context",
                    "nameCaptureInfo", c2_i3);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->name, 15, 0U,
      0U, 0U, 2, 1, strlen(c2_r0->name)), "name",
                    "nameCaptureInfo", c2_i3);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->dominantType,
      15, 0U, 0U, 0U, 2, 1, strlen(c2_r0->dominantType)),
                    "dominantType", "nameCaptureInfo", c2_i3);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", c2_r0->resolved, 15,
      0U, 0U, 0U, 2, 1, strlen(c2_r0->resolved)), "resolved"
                    , "nameCaptureInfo", c2_i3);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->fileLength,
      7, 0U, 0U, 0U, 0), "fileLength", "nameCaptureInfo",
                    c2_i3);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->fileTime1, 7,
      0U, 0U, 0U, 0), "fileTime1", "nameCaptureInfo", c2_i3);
    sf_mex_addfield(c2_m0, sf_mex_create("nameCaptureInfo", &c2_r0->fileTime2, 7,
      0U, 0U, 0U, 0), "fileTime2", "nameCaptureInfo", c2_i3);
  }

  sf_mex_assign(&c2_nameCaptureInfo, c2_m0);
  return c2_nameCaptureInfo;
}

static const mxArray *c2_emlrt_marshallOut(uint8_T c2_u)
{
  const mxArray *c2_y = NULL;
  c2_y = NULL;
  sf_mex_assign(&c2_y, sf_mex_create("y", &c2_u, 3, 0U, 0U, 0U, 0));
  return c2_y;
}

static real_T c2_emlrt_marshallIn(const mxArray *c2_y, char *c2_name)
{
  real_T c2_b_y;
  real_T c2_d0;
  sf_mex_import(c2_name, sf_mex_dup(c2_y), &c2_d0, 1, 0, 0U, 0, 0U, 0);
  c2_b_y = c2_d0;
  sf_mex_destroy(&c2_y);
  return c2_b_y;
}

static uint8_T c2_b_emlrt_marshallIn(const mxArray
  *c2_b_is_active_c2_dstatcom_dPQ, char *c2_name)
{
  uint8_T c2_y;
  uint8_T c2_u0;
  sf_mex_import(c2_name, sf_mex_dup(c2_b_is_active_c2_dstatcom_dPQ), &c2_u0, 1,
                3, 0U, 0, 0U, 0);
  c2_y = c2_u0;
  sf_mex_destroy(&c2_b_is_active_c2_dstatcom_dPQ);
  return c2_y;
}

static void init_io_bus_offset(void)
{
}

static void init_dsm_address_info(void)
{
}

/* SFunction Glue Code */
void sf_c2_dstatcom_dPQ_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(3707107809U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(2852323032U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(3691753082U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2203876883U);
}

mxArray *sf_c2_dstatcom_dPQ_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] = { "checksum", "inputs", "parameters",
    "outputs" };

  mxArray *mxAutoinheritanceInfo = mxCreateStructMatrix(1,1,4,
    autoinheritanceFields);

  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(1697866589U);
    pr[1] = (double)(320771036U);
    pr[2] = (double)(3491876301U);
    pr[3] = (double)(3235412945U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(6);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }

  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,
                mxREAL));
  }

  {
    const char *dataFields[] = { "size", "type", "complexity" };

    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);

    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }

    {
      const char *typeFields[] = { "base", "fixpt" };

      mxArray *mxType = mxCreateStructMatrix(1,1,2,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }

    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }

  return(mxAutoinheritanceInfo);
}

static mxArray *sf_get_sim_state_info_c2_dstatcom_dPQ(void)
{
  const char *infoFields[] = { "chartChecksum", "varInfo" };

  mxArray *mxInfo = mxCreateStructMatrix(1, 1, 2, infoFields);
  char *infoEncStr[] = {
    "100 S1x2'type','srcId','name','auxInfo'{{M[1],M[5],T\"y\",},{M[8],M[0],T\"is_active_c2_dstatcom_dPQ\",}}"
  };

  mxArray *mxVarInfo = sf_mex_decode_encoded_mx_struct_array(infoEncStr, 2, 10);
  mxArray *mxChecksum = mxCreateDoubleMatrix(1, 4, mxREAL);
  sf_c2_dstatcom_dPQ_get_check_sum(&mxChecksum);
  mxSetField(mxInfo, 0, infoFields[0], mxChecksum);
  mxSetField(mxInfo, 0, infoFields[1], mxVarInfo);
  return mxInfo;
}

static void chart_debug_initialization(SimStruct *S, unsigned int
  fullDebuggerInitialization)
{
  if (!sim_mode_is_rtw_gen(S)) {
    if (ssIsFirstInitCond(S) && fullDebuggerInitialization==1) {
      /* do this only if simulation is starting */
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart
          (_dstatcom_dPQMachineNumber_,
           2,
           1,
           1,
           2,
           0,
           0,
           0,
           0,
           0,
           &(chartInstance.chartNumber),
           &(chartInstance.instanceNumber),
           ssGetPath(S),
           (void *)S);
        if (chartAlreadyPresent==0) {
          /* this is the first instance */
          init_script_number_translation(_dstatcom_dPQMachineNumber_,
            chartInstance.chartNumber);
          sf_debug_set_chart_disable_implicit_casting
            (_dstatcom_dPQMachineNumber_,chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_dstatcom_dPQMachineNumber_,
            chartInstance.chartNumber,
            0,
            0,
            0);

          {
            unsigned int dimVector[1];
            dimVector[0]= 6;
            _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,1,&(dimVector[0]),0,0,0,0.0,
                                1.0,0,"u",0,c2_sf_marshall);
          }

          _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"y",0,
                              c2_b_sf_marshall);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }

        _SFD_CV_INIT_CHART(0,0,0,0);

        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,1,0,0,0,8,1);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,136);
        _SFD_CV_INIT_EML_IF(0,0,26,112,122,135);

        {
          static int condStart[] = { 30, 42, 58, 68, 77, 86, 95, 104 };

          static int condEnd[] = { 40, 52, 66, 75, 84, 93, 102, 111 };

          static int pfixExpr[] = { 0, 1, -2, 2, 3, -2, 4, -2, 5, -2, 6, -2, 7,
            -2, -3 };

          _SFD_CV_INIT_EML_MCDC(0,0,29,112,8,0,&(condStart[0]),&(condEnd[0]),15,
                                &(pfixExpr[0]));
        }

        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if (chartAlreadyPresent==0) {
          _SFD_TRANS_COV_MAPS(0,
                              0,NULL,NULL,
                              0,NULL,NULL,
                              1,NULL,NULL,
                              0,NULL,NULL);
        }

        {
          real_T (*c2_u)[6];
          real_T *c2_y;
          c2_y = (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
          c2_u = (real_T (*)[6])ssGetInputPortSignal(chartInstance.S, 0);
          _SFD_SET_DATA_VALUE_PTR(0U, c2_u);
          _SFD_SET_DATA_VALUE_PTR(1U, c2_y);
        }
      }
    } else {
      sf_debug_reset_current_state_configuration(_dstatcom_dPQMachineNumber_,
        chartInstance.chartNumber,chartInstance.instanceNumber);
    }
  }
}

static void sf_opaque_initialize_c2_dstatcom_dPQ(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S,0);
  initialize_params_c2_dstatcom_dPQ();
  initialize_c2_dstatcom_dPQ();
}

static void sf_opaque_enable_c2_dstatcom_dPQ(void *chartInstanceVar)
{
  enable_c2_dstatcom_dPQ();
}

static void sf_opaque_disable_c2_dstatcom_dPQ(void *chartInstanceVar)
{
  disable_c2_dstatcom_dPQ();
}

static void sf_opaque_gateway_c2_dstatcom_dPQ(void *chartInstanceVar)
{
  sf_c2_dstatcom_dPQ();
}

static mxArray* sf_opaque_get_sim_state_c2_dstatcom_dPQ(void *chartInstanceVar)
{
  mxArray *st = (mxArray *) get_sim_state_c2_dstatcom_dPQ();
  return st;
}

static void sf_opaque_set_sim_state_c2_dstatcom_dPQ(void *chartInstanceVar,
  const mxArray *st)
{
  set_sim_state_c2_dstatcom_dPQ(sf_mex_dup(st));
}

static void sf_opaque_terminate_c2_dstatcom_dPQ(void *chartInstanceVar)
{
  if (sim_mode_is_rtw_gen(chartInstance.S) || sim_mode_is_external
      (chartInstance.S)) {
    sf_clear_rtw_identifier(chartInstance.S);
  }

  finalize_c2_dstatcom_dPQ();
}

extern unsigned int sf_machine_global_initializer_called(void);
static void mdlProcessParameters_c2_dstatcom_dPQ(SimStruct *S)
{
  int i;
  for (i=0;i<ssGetNumRunTimeParams(S);i++) {
    if (ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }

  if (sf_machine_global_initializer_called()) {
    initialize_params_c2_dstatcom_dPQ();
  }
}

static void mdlSetWorkWidths_c2_dstatcom_dPQ(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S) || sim_mode_is_external(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("dstatcom_dPQ","dstatcom_dPQ",2);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetRTWCG(S,sf_rtw_info_uint_prop("dstatcom_dPQ","dstatcom_dPQ",2,"RTWCG"));
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("dstatcom_dPQ",
      "dstatcom_dPQ",2,"gatewayCannotBeInlinedMultipleTimes"));
    if (chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"dstatcom_dPQ","dstatcom_dPQ",2,1);
      sf_mark_chart_reusable_outputs(S,"dstatcom_dPQ","dstatcom_dPQ",2,1);
    }

    sf_set_rtw_dwork_info(S,"dstatcom_dPQ","dstatcom_dPQ",2);
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(31386180U));
  ssSetChecksum1(S,(2632570614U));
  ssSetChecksum2(S,(1163924555U));
  ssSetChecksum3(S,(3630025089U));
  ssSetmdlDerivatives(S, NULL);
  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c2_dstatcom_dPQ(SimStruct *S)
{
  if (sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "dstatcom_dPQ", "dstatcom_dPQ",2);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void mdlStart_c2_dstatcom_dPQ(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c2_dstatcom_dPQ;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c2_dstatcom_dPQ;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c2_dstatcom_dPQ;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c2_dstatcom_dPQ;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c2_dstatcom_dPQ;
  chartInstance.chartInfo.getSimState = sf_opaque_get_sim_state_c2_dstatcom_dPQ;
  chartInstance.chartInfo.setSimState = sf_opaque_set_sim_state_c2_dstatcom_dPQ;
  chartInstance.chartInfo.getSimStateInfo =
    sf_get_sim_state_info_c2_dstatcom_dPQ;
  chartInstance.chartInfo.zeroCrossings = NULL;
  chartInstance.chartInfo.outputs = NULL;
  chartInstance.chartInfo.derivatives = NULL;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c2_dstatcom_dPQ;
  chartInstance.chartInfo.mdlStart = mdlStart_c2_dstatcom_dPQ;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c2_dstatcom_dPQ;
  chartInstance.chartInfo.extModeExec = NULL;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo)));/* register the chart instance with simstruct */
  if (!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }

  chart_debug_initialization(S,1);
}

void c2_dstatcom_dPQ_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c2_dstatcom_dPQ(S);
    break;

   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c2_dstatcom_dPQ(S);
    break;

   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c2_dstatcom_dPQ(S);
    break;

   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
                         "Error calling c2_dstatcom_dPQ_method_dispatcher.\n"
                         "Can't handle method %d.\n", method);
    break;
  }
}
